/* This file is part of GNU Radius.
   Copyright (C) 2005 Free Software Foundation, Inc.

   Written by Sergey Poznyakoff

   GNU Radius is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   GNU Radius is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with GNU Radius; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#include <radius/radius.h>
#include <httpd.h>
#include <http_config.h>
#include <http_core.h>
#include <http_log.h>
#include <http_protocol.h>

typedef struct auth_config_struct {
	char *config_dir;
	int auth_authoritative;
};

static const char *
set_auth_slot(cmd_parms *cmd, void *offset, char *f, char *t)
{
	return ap_set_file_slot(cmd, offset, f);
}

static const command_rec command_table[] =
{
    {"RadiusConfigDirectory", set_auth_slot,
     (void *) XtOffsetOf(auth_config_rec, config_dir), OR_AUTHCFG, TAKE12,
     "full name of the radius configuration directory"},
    {"AuthAuthoritative", set_auth_slot,
     (void *) XtOffsetOf(auth_config_rec, auth_authoritative),
     OR_AUTHCFG, FLAG,
     "Set to 'off' to allow access control to be passed along to "
     "lower modules if the UserID is not known to this module"},
    {NULL}
};


static void *
create_dir_config(pool *p, char *d)
{
    auth_config_rec *sec = ap_pcalloc(p, sizeof(auth_config_rec));
    sec->config_dir = NULL;	
    sec->auth_authoritative = 1;
    return sec;
}

static int
check_user_id (request_rec *r)
{
}

static int
check_auth(request_rec *r)
{
}



module MODULE_VAR_EXPORT auth_module =
{
    STANDARD_MODULE_STUFF,
    NULL,			/* initializer */
    create_dir_config,	        /* dir config creater */
    NULL,			/* dir merger --- default is to override */
    NULL,			/* server config */
    NULL,			/* merge server config */
    command_table,		/* command table */
    NULL,			/* handlers */
    NULL,			/* filename translation */
    check_user_id,	        /* check_user_id */
    check_auth,		        /* check auth */
    NULL,			/* check access */
    NULL,			/* type_checker */
    NULL,			/* fixups */
    NULL,			/* logger */
    NULL,			/* header parser */
    NULL,			/* child_init */
    NULL,			/* child_exit */
    NULL			/* post read-request */
};

